﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Script.Serialization;
using System.Web.Services;
using DLLErrorTicketMaster;
using System.Data;
using DllUtility;
[WebService(Namespace = "http://tempuri.org/")]
[WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
// To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
[System.Web.Script.Services.ScriptService]
public class WErrorTicketMaster : System.Web.Services.WebService
{

    public WErrorTicketMaster()
    {
        gZipCompression.fn_gZipCompression();
        //Uncomment the following line if using designed components 
        //InitializeComponent(); 
    }

    [WebMethod(EnableSession = true)]
    public string GenerateTicket(string dataValue)
    {
        
        if (Session["EmpAutoId"] != null)
        {           
            var jss = new JavaScriptSerializer();
            var jdv = jss.Deserialize<dynamic>(dataValue);
            PL_ErrorTicketMaster pobj = new PL_ErrorTicketMaster();
            try
            {
                pobj.ByEmployee = Convert.ToInt32(Session["EmpAutoId"]);
                pobj.Type = jdv["Type"];
                pobj.Priority = jdv["Priority"];
                pobj.Subject = jdv["Subject"];
                pobj.PageUrl = jdv["PageUrl"];
                pobj.Description = jdv["Description"];
                pobj.Status = "Open";
                pobj.Attach = jdv["Attach"];
                BL_ErrorTicketMaster.Insert(pobj);
                if (!pobj.isException)
                {
                    sendMail(pobj);
                    return "true";
                }
                else
                {
                    return pobj.exceptionMessage;
                }
            }
            catch (Exception ex)
            {
                pobj.isException = true;
                pobj.exceptionMessage = ex.Message;
                return "Oops,something wents wrongs.!!!";
            }
        }
        else
        {
            return "UnAuthorized Access";
        }
    }

     [WebMethod(EnableSession=true)]
    protected void sendMail(PL_ErrorTicketMaster pobj1)
    {
      
        int byEmp = Convert.ToInt32(Session["EmpAutoId"]);
        string generatedby = Session["EmpFirstName"].ToString();
        string cc = Session["UserEmail"].ToString();
        string Emailadmin ="";
        string bcc = "";
        PL_ErrorTicketMaster pobj = new PL_ErrorTicketMaster();
        pobj.ByEmployee = byEmp;
        BL_ErrorTicketMaster.selectreceiver(pobj);
        if (pobj.Ds.Tables[0].Rows.Count > 0)
        {
            foreach (DataRow dr in pobj.Ds.Tables[0].Rows)
            {
                Emailadmin += dr["EmailId"].ToString() + ",";
            }
        }       
        
        if (Emailadmin.Trim() != "")
        {
            try
            {
                string Return = "";
                string MessageSubject = "A1WHM - New ticket " + pobj1.TicketID + " on " + pobj.Ds.Tables[0].Rows[0]["Companyid"].ToString() + " (Subject : " + pobj1.Subject + ")";
                string body = "";
                body += "<html xmlns='http://www.w3.org/1999/xhtml'><head></head><body><form id='form1' runat='server'>";
                body += "<table style='width: 812px; text-align: left; font-family: Helvetica, Arial, sans-serif;font-size: 13px;' cellpadding='2' cellspacing='2'>";
                body += " <tr><td colspan='3'>Dear Admin/Developers,</td> </tr>";
                body += "<tr><td colspan='3'>A request <b>(" + pobj1.TicketID + ")</b> has been received</td></tr>";
                body += "<tr style='height:10px'> <td colspan='3'></td></tr>";
                body += "<tr><td colspan='3'><table  width='100%' cellpadding='2' cellspacing='2' style='border: 1px solid #F2F2F2'>";
                body += "<tr style='background-color: #ffefe4;'>";
                body += " <td style='width:33%'><b> Type</b></td><td style='width:33.5%'><b> Priority</b></td><td style='width:33.5%'><b> Generated By</b></td></tr>";
                body += "<tr> <td> " + pobj1.Type + " </td> <td>   " + pobj1.Priority + " </td> <td> " + generatedby + " </td> </tr>";
                body += "</table></td> </tr>";
                body += "<tr><td colspan='3'> <table width='100%' cellpadding='2' cellspacing='2' style='border: 1px solid #F2F2F2'>";
                body += " <tr style='background-color: #ffefe4;'>";
                body += " <td colspan='3'><b> Description :</b></td> </tr>";
                body += " <tr> <td colspan='3'> " + pobj1.Description + " </td> </tr>";
                body += " </table> </td> </tr>";
                body += "<tr style='height:10px'> <td colspan='3'></td></tr>";
                body += "<tr> <td colspan='3'> Please check CRM to resolve the issue  </td></tr>";
                body += "<tr style='height:20px'> <td colspan='3'></td></tr>";
                body += "<tr> <td colspan='3'> Thank You</td></tr>";
                body += "<tr> <td colspan='3'> PSM automated email. </td> </tr>";
                body += "<tr> <td colspan='3' style='color:Red;'> **This is an automated email please do not reply** </td> </tr>";
                body += "</table></form></body></html>";
                string emailmsg = MailSending.SendMailResponse(Emailadmin.ToString(), cc, bcc.ToString(), MessageSubject.ToString(), body.ToString(), "Developer");
                if (emailmsg == "Successful")
                {
                    Return = "True";
                }
                else
                {
                    Return = "False";
                }
               
            }
            catch (Exception) { }
        }

    }
   

}